#include <iostream>
#include <algorithm>

using namespace std;

int ocena(int *i, int *j) {
    int rez = 0;
    while(i < j) {
        if(rez <= *i)
            rez++;
        else
            rez--;
        i++;
    }
    return rez;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    int t, n, k;
    cin >> t >> n >> k;
    int a[n];
    for(int i = 0; i < n; i++)
        cin >> a[i];
    
    sort(a, a + n);
    
    for(int i = 0; i <= n/2; i++) {
        int trenutnaOcena = ocena(a, a + n);
        if(trenutnaOcena == k) {
            cout << "DA\n";
            if(t)
                for(int i = 0; i < n; i++)
                    cout << a[i] << ' ';
            return 0;
        }
        swap(a[i], a[n - 1 - i]);
    }
    cout << "NE\n";
    
    return 0;
}